var type = require('./type.js');
var object = require('../share/util/object.js');
var array = require('../share/util/array.js');

function clone(value) {
    var tp = type(value);
    if (tp in clone) {
        return clone[tp](value);
    } else {
        return value;
    }
}

function clonePrimitive(value) {
    return value;
}

clone['String'] = clonePrimitive;
clone['Number'] = clonePrimitive;
clone['Boolean'] = clonePrimitive;
clone['Function'] = clonePrimitive;
clone['Undefined'] = clonePrimitive;
clone['Null'] = clonePrimitive;
clone['Date'] = function(value) {
    return new Date(value);
};
clone['Object'] = function(obj) {
    var copy;
    if (type.isFunction(obj.clone)) {
        copy = obj.clone();
    } else {
        if (type.isFunction(obj.clazz)) {
            copy = new obj.clazz()();
        } else {
            copy = new obj.constructor();
        }
        object.each(obj, function(value, key) {
            copy[key] = clone(value);
        });
    }
    return copy;
};
clone['Array'] = function(arr) {
    var copy = [];
    array.each(arr, function(item) {
        copy.push(clone(item));
    });
    return copy;
};

module.exports = clone;