function type(obj) {
    if (typeof obj === 'undefined') {
        return 'Undefined';
    }
    return Object.prototype.toString.call(obj).slice(8, -1);
}
type.isBoolean = function(obj) {
    return this(obj) === 'Boolean';
};
type.isString = function(obj) {
    return this(obj) === 'String';
};
type.isFunction = function(obj) {
    return this(obj) === 'Function';
};
type.isObject = function(obj) {
    return this(obj) === 'Object';
};
type.isNumber = function(obj) {
    return this(obj) === 'Number';
};
type.isArray = function(obj) {
    return this(obj) === 'Array';
};
type.clazzName = function(obj) {
    var type = this(obj);
    if (type === 'Object') {
        return obj.constructor.name;
    }
    return type;
};
type.is = function(obj, clazz, strict) {
    return this.clazzName(obj) === clazz.prototype.constructor.name || (!strict && clazz.prototype.isPrototypeOf(obj));
};
type.isDefined = function(obj) {
    return this(obj) !== 'Undefined';
};
type.isNil = function(obj) {
    return this(obj) === 'Null' || this(obj) === 'Undefined';
};

module.exports = type;