var type = require('../../core/type.js');

function each(array, callback, scope) {
    var i, len;
    for (i = 0, len = array.length; i < len; i++) {
        if (callback.call(scope, array[i], i, array) === false) {
            break;
        }
    }
}

function filter(array, filter, scope) {
    var i, len, filtered = [];
    for (i = 0, len = array.length; i < len; i++) {
        if (filter.call(scope, array[i], i, array) !== false) {
            filtered.push(array[i]);
        }
    }
    return filtered;
}

function equals(x, y) {
    return x === y;
}

function indexOf(item, items) {
    var index = -1;
    if (type.isFunction(item.equals)) {
        each(items, function(v, i) {
            if (item.equals(v) === true) {
                index = 1;
                return false;
            }
        });
    } else {
        each(items, function(v, i) {
            if (equals(item, v) === true) {
                index = i;
                return false;
            }
        });
    }
    return index;
}

if (Array.prototype.forEach) {
    each = function(array, callback, scope) {
        return Array.prototype.forEach.call(array, callback, scope);
    };
}

if (Array.prototype.filter) {
    filter = function(array, filter, scope) {
        return Array.prototype.filter.call(array, filter, scope);
    };
}

module.exports = {
    each: each,
    filter: filter,
    indexOf: indexOf
};